unit BlackHole;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TBlackHole = class(TShape)
  private
  protected
  public
    procedure Loaded; override;
  published
  end;

procedure Register;

implementation

procedure TBlackHole.Loaded;
var
  FormRgn, HoleRgn: THandle;
  Margin: Integer;
  X, Y, W, H, S: Integer;
  ParentForm: TCustomForm;
begin
  ParentForm := TCustomForm(Owner);
  with ParentForm do
  begin
       Margin := (Width - ClientWidth) div 2;
       FormRgn := CreateRectRgn(0, 0, Width, Height);
       X := Margin;
       Y := Height - ClientHeight - Margin;

       X := X + self.left + Pen.Width;
       Y := Y + self.top  + Pen.Width;
       W := self.Width - (Pen.Width*2);
       H := self.Height - (Pen.Width*2);
       if Pen.Width = 0 then
       begin
            Dec(W);
            Dec(H);
       end;
       if W < H then S := W else S := H;
       if Shape in [stSquare, stRoundSquare, stCircle] then
       begin
            Inc(X, (W - S) div 2);
            Inc(Y, (H - S) div 2);
            W := S;
            H := S;
       end;
       case Shape of
         stRectangle, stSquare:
            HoleRgn := CreateRectRgn(X, Y, X + W, Y + H);
         stRoundRect, stRoundSquare:
            HoleRgn := CreateRoundRectRgn(X, Y, X + W, Y + H, S div 4, S div 4);
         stCircle, stEllipse:
            HoleRgn := CreateEllipticRgn(X, Y, X + W, Y + H);
       end;
       CombineRgn(FormRgn, FormRgn, HoleRgn, RGN_DIFF);
  end;
  SetWindowRgn(ParentForm.Handle, FormRgn, True);
end;

procedure Register;
begin
  RegisterComponents('JustForFun', [TBlackHole]);
end;

end.
